<?php
/*
 * スタッフ管理システム設定ファイル
 * Copyright (c) 2012 by Crytus All rights reserved.
 *
 * このファイルの設定部分以外は修正しないでください。
 * 修正された場合は、動作の保証やサポートは行なえません。
 */
// エラー出力の指定
error_reporting (E_ALL & ~E_NOTICE & ~E_WARNING & ~E_STRICT & ~E_DEPRECATED);

ini_set("short_open_tag", "0");
ini_set("magic_quotes_gpc", "0");
ini_set("mbstring.encoding_translation", "0");
ini_set("max_execution_time", 0);

// スクリプトの漢字コード（このファイルの漢字コードと一致させてください）
define("SCRIPT_ENCODING", "UTF-8");	// UTF-8の場合先頭の'//'を取ります。
//define("SCRIPT_ENCODING", "SJIS");	// Shift-JISの場合先頭の'//'を取ります。

// データベースの漢字コード
define("DB_ENCODING", "UTF-8");

// データベースファイルの場所と名前
$DB_URI = "data/staff.sqlite";

// 一覧の1ページあたりの最大件数
define("PAGE_LIMIT", 100);	// 100件

// メールの言語は日本語（英語、日本語以外はUTF-8を使用）
define("MAIL_ENCODING", "JIS");

$week = array("日","月","火","水","木","金","土",);
$free_ver = "1";

//-------------------------------------------------------------
// 設定（必要により修正してください）
$setup = array(
	// 種類の設定。"3"以降も利用可。
	"items" => array(
		"1" => "早番",
		"2" => "遅番",
	),
	// トップページお知らせ件数
	"info_max" => 10,
	// 特別リスト用
	"option_list" => array(
		"0" => "",
		"1" => "おすすめ",
	),
	// 出勤設定
	"schedule_list" => array(
		"0" => "",
		"1" => "出勤",
	),
	// オプションのアイコン設定（オプション画像を使う場合は管理画面の設定にあわせて指定してください）
	"icons" => array(
		"1" => array(	// 早番
			"1" => "",
			"2" => "",
			"3" => "",
			"4" => "",
			"5" => "",
			"6" => "",
			"7" => "",
			"8" => "",
			"9" => "",
			"10" => "",
			"11" => "",
			"12" => "",
			"13" => "",
			"14" => "",
			"15" => "",
			"16" => "",
			"17" => "",
			"18" => "",
			"19" => "",
			"20" => "",
		),
		"2" => array(	// 遅番
			"1" => "",
			"2" => "",
			"3" => "",
			"4" => "",
			"5" => "",
			"6" => "",
			"7" => "",
			"8" => "",
			"9" => "",
			"10" => "",
			"11" => "",
			"12" => "",
			"13" => "",
			"14" => "",
			"15" => "",
			"16" => "",
			"17" => "",
			"18" => "",
			"19" => "",
			"20" => "",
		),
	),
);

//--------------------
// メール設定
$from_mail = "";	// メールの送信元
$admin_mail = "";	// 管理者にメールを送信する場合
$from_name = "SAMPLE CLUB";	// 送信元の名称
$subject = "予約のお問合せを受け付けました";		// ユーザー宛てのメールの件名
$subject_admin = "予約のお問合せがありました";	// 管理者宛てのメールの件名
// メール文面
$pre_user = "次の通り予約のお問い合わせを承りました\n";		// ユーザー宛ての前文
$post_user = "改めて回答をお送りいたしますので、しばらくお待ちください";	// ユーザー宛ての後文
//
$pre_admin = "次の予約の問合せがありました\n";	// 管理者宛ての前文
$post_admin = "";	// 管理者宛ての後文
$mail_sama = "様";	// 敬称
//
$mail_body = "■スタッフID：{info_id}\n" .
	"■スタッフ名：{title}\n" .
	"■お名前：{name}\n" .
	"■メールアドレス：{email}\n" .
	"■ご予約希望日：{month}月{day}日\n" .
	"■メッセージ：\n" .
	"{comment}\n";
// エラーメッセージ
$error_msg1 = "お名前を入力してください";
$error_msg2 = "メールアドレスを入力してください";
$error_msg3 = "メッセージを入力してください";
$error_msg4 = "ご予約希望日を入力してください";

